unit Form4;
interface
uses
  Tasks,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Buttons, ShellApi, StdCtrls, Rot3DLbl;

type
  TFForm4 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Image1: TImage;
    rotlabel: TRotateable3DLabel;
    procedure FormCreate(Sender: TObject);
    procedure SButtonClick(Sender: TObject);
    procedure SpeedButton1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel2DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure Panel2DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Panel2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    max        : Integer;
    DragOn     : Boolean;
    SBut       : array[0 .. 29] of TSpeedButton;
  public
  end;

var
  FForm4: TFForm4;

implementation
{$R *.DFM}

procedure TFForm4.FormCreate(Sender: TObject);
var
 i, zeil, spa, maxzeil   :Integer;

BEGIN
 zeil    := 0;
 spa     := 0;
 maxzeil := 5;                        {5 Zeilen x 6 Spalten macht 30}

 max := drpList.Count;
 if max > 30 then max := 30;          {mehr wollen wir nicht}

 for i := 0 to max -1 do begin
  SBut[i] := TSpeedButton.Create(Self);  {das ist einer}

  with SBut[i] do begin
   if i = maxzeil then begin          {nchste Spalte ?}
    inc(spa);
    maxzeil:= maxzeil + 5;            {neuer Zeilenwert}
    zeil := 0;
   end;
   Width       := 35;
   Height      := Width;
   Hint        := ExtractFileName(drpList.Strings[i]);
   Name        := 'S'+ IntToStr(i+1);
   Top         := 2 + (zeil * (Height + 2));
   Left        := 2 + (spa  * (Width  + 2));
   Tag         := i;
   parent      := Panel1;
   OnClick     := SButtonClick;       {Startrampe}
   OnMouseUp   := SpeedButton1MouseUp;{zum draggen}
   OnMouseDown := SpeedButton1MouseDown;
   OnMouseMove := SpeedButton1MouseMove;
   ShowHint    := True;
   Glyph       := TASKSF1.IconToBit(drpList.Strings[i],32,32);
   if NOT ICOErr then                 {Bild vorhanden?}
    BMP2.Free;                        {die Ressourcen}
   inc (zeil);
   end;
 end;
END;

procedure TFForm4.SButtonClick(Sender : TObject);
var
 i   : Integer;

BEGIN
 if NOT (DragOn) then  begin          {kein Drag!}
  i := (Sender as TSpeedButton).Tag;  {index ermittelt}
  TASKSF1.Datei_starten('',
                        drpList.Strings[i],
                        '');
  close;                              {alles erledigt}
 end;
END;

procedure TFForm4.SpeedButton1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
BEGIN
 if Button = mbRight then             {rechte Maustaste?}
  DragOn  := True;
END;

procedure TFForm4.SpeedButton1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
BEGIN
 if Button = mbRight then             {na, was denn nun?}
  DragOn  := False;
END;

procedure TFForm4.SpeedButton1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
BEGIN
 if DragOn then                       {also doch draggen!}
  (Sender as TSpeedButton).BeginDrag(False);
END;

procedure TFForm4.Panel2DragDrop(Sender, Source: TObject; X, Y: Integer);
var
 i        :Integer;

BEGIN
 i := (Source as TSpeedButton).Tag;
 with SBut[i] do begin                {im Mlleimer!}
  Visible := False;                   {verstecken und }
  drpList.Strings[i] := '*';          {markieren !}
  Enabled := False;
 end;
END;

procedure TFForm4.Panel2DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
BEGIN
 if Source is TSpeedButton then
       Accept := True                 {nur SpeedButton akzeptieren}
 else  Accept := False;
END;

procedure TFForm4.FormClose(Sender: TObject; var Action: TCloseAction);
var
 i       : Integer;

BEGIN
 for  i:= 0 to max-1 do               {alle Button free,}
  SBut[i].Free;                       {die Ressourcen}

 i := 0;
 while i <> -1 do begin
  i := drpList.IndexOf('*');          {wenn markiert, dann}
  if i >= 0 then
   drpList.Delete(i);                 {lschen}
 end;
                                      {Inidatei aktualisieren}
 TASKSF1.SaveIni;                     {Ressourcen frei}
 Action := caFree;
END;

procedure TFForm4.Panel2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
BEGIN
 rotlabel.Visible := True;            {nur Spielerei}
END;
END.
